<?php





	function ttech_portfolio_post_type() 
	{
		$labels = array(
			'name'               => _x( 'Portfolio', 'post type general name', 'ttech' ),
			'singular_name'      => _x( 'Portfolio', 'post type singular name', 'ttech' ),
			'menu_name'          => _x( 'Portfolio', 'admin menu', 'ttech' ),
			'name_admin_bar'     => _x( 'Portfolio', 'add new on admin bar', 'ttech' ),
			'add_new'            => _x( 'Add New', 'Portfolio', 'ttech' ),
			'add_new_item'       => __( 'Add New Portfolio', 'ttech' ),
			'new_item'           => __( 'New Portfolio', 'ttech' ),
			'edit_item'          => __( 'Edit Portfolio', 'ttech' ),
			'view_item'          => __( 'View Portfolio', 'ttech' ),
			'all_items'          => __( 'All Portfolio', 'ttech' ),
			'search_items'       => __( 'Search Portfolio', 'ttech' ),
			'parent_item_colon'  => __( 'Parent Portfolio:', 'ttech' ),
			'not_found'          => __( 'No Portfolio found.', 'ttech' ),
			'not_found_in_trash' => __( 'No Portfolio found in Trash.', 'ttech' )
		);
		
		$args = array(
			'labels'             => $labels,
			'public'             => true,
			'menu_icon'          =>'dashicons-images-alt2',		
			'exclude_from_search'=> true,
			'show_ui'            => true,
			'show_in_menu'       => true,
			'query_var'          => true,
			'rewrite'            => array( 'slug' => 'portfolios' ),
			'capability_type'    => 'post',
			'has_archive'        => true,
			'hierarchical'       => false,
			'menu_position'      => null,
			'supports'           => array('title','editor', 'thumbnail')
		);
		
		register_post_type( 'portfolio' , $args );
		
		$labels = array(
			'name'              => _x( 'Categories', 'taxonomy general name', 'ttech' ),
			'singular_name'     => _x( 'Category', 'taxonomy singular name', 'ttech' ),
			'search_items'      => __( 'Search Categories', 'ttech' ),
			'all_items'         => __( 'All Categories', 'ttech' ),
			'parent_item'       => __( 'Parent Category', 'ttech' ),
			'parent_item_colon' => __( 'Parent Category:', 'ttech' ),
			'edit_item'         => __( 'Edit Category', 'ttech' ),
			'update_item'       => __( 'Update Category', 'ttech' ),
			'add_new_item'      => __( 'Add New Category', 'ttech' ),
			'new_item_name'     => __( 'New Category Name', 'ttech' ),
			'menu_name'         => __( 'Categories', 'ttech' ),
		);

		$args = array(
			'public'            => false,
			'hierarchical'      => true,
			'labels'            => $labels,
			'show_ui'           => true,
			'show_admin_column' => true,
			'show_in_nav_menus' => false,
			'query_var'         => false,
			'rewrite'           => array( 'slug' => 'portfolio-category' ),
		);
		
		register_taxonomy( 'portfolio_cat', array( 'portfolio' ), $args );
	}
	add_action( 'init', 'ttech_portfolio_post_type' );