<?php



use Elementor\Widget_Base;
use Elementor\Controls_Manager;
use Elementor\Group_Control_Typography;

if(!defined('ABSPATH')) exit;


class techtimeButton extends Widget_Base{

	public function get_name(){
		return "techtime-button";
	}
	
	public function get_title(){
		return "techtime Button";
	}
	
	public function get_icon(){
		return "eicon-button";
	}

	public function get_categories(){
		return ['techtime-category'];
	}

	protected function _register_controls(){

		$this->start_controls_section(
			'button_section',
			[
				'label' => __( 'Button', 'techtime-elementor-extension' ),
				'tab' => Controls_Manager::TAB_CONTENT,
			]
		);
			$this->add_control(
				'button_text',
				[
					'label' => __( 'Button Text', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::TEXT,
					'dynamic' => [
						'active' => true,
					],
					'placeholder' => __( 'Enter your button text', 'techtime-elementor-extension' ),
					'label_block' => true,
					'default' => __( 'Button', 'techtime-elementor-extension' ),
				]
			);
			$this->add_control(
				'button_url',
				[
					'label' => __( 'Button URL', 'techtime-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::URL,
					'placeholder' => __( 'https://your-link.com', 'techtime-elementor-extension' ),
				]
			);
			$this->add_control(
				'show_button',
				[
					'label' => __( 'Show Button', 'techtime-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::SWITCHER,
					'label_on' => __( 'Show', 'techtime-elementor-extension' ),
					'label_off' => __( 'Hide', 'techtime-elementor-extension' ),
					'return_value' => 'yes',
					'default' => 'no',
				]
			);
			$this->add_control(
				'button_icon',
				[
					'label' => __( 'Button Icon', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::ICONS,
				]
			);
		$this->end_controls_section();

/*
==========
Style Tab
==========
*/

		$this->start_controls_section(
			'general_section',
			[
				'label' => __( 'General', 'techtime-elementor-extension' ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);

			$this->add_control(
				'select_style',
				[
					'label' => __( 'Select Style', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::SELECT,
					'options' => [
						'one' => __( 'One', 'techtime-elementor-extension' ),
						'two' => __( 'Two', 'techtime-elementor-extension' ),
						'three' => __( 'Three', 'techtime-elementor-extension' ),
						'four' => __( 'Four', 'techtime-elementor-extension' ),

					],
					'default' => 'one',
					
				]
			);
			$this->add_responsive_control(
				'text_align',
				[
					'label' => __( 'Alignment', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::CHOOSE,
					'options' => [
						'left' => [
							'title' => __( 'Left', 'techtime-elementor-extension' ),
							'icon' => 'eicon-text-align-left',
						],
						'center' => [
							'title' => __( 'Center', 'techtime-elementor-extension' ),
							'icon' => 'eicon-text-align-center',
						],
						'right' => [
							'title' => __( 'Right', 'techtime-elementor-extension' ),
							'icon' => 'eicon-text-align-right',
						],
						'justify' => [
							'title' => __( 'Justified', 'techtime-elementor-extension' ),
							'icon' => 'eicon-text-align-justify',
						],
					],
					'selectors' => [
						'{{WRAPPER}} .techtime-button-box' => 'text-align: {{VALUE}};',
					],
				]
			);
		$this->end_controls_section();


		$this->start_controls_section(
			'icon_section_style',
			[
				'label' => __( 'Icon', 'techtime-elementor-extension' ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);
		$this->start_controls_tabs(
			'style_tabs'
		);
		$this->start_controls_tab(
			'style_normal_tab',
			[
				'label' => __( 'Normal', 'techtime-elementor-extension' ),
			]
		);

		$this->end_controls_tab();
		$this->end_controls_tabs();

			$this->add_control(
				'height',
				[
					'label' => __( 'Height', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => 0,
							'max' => 1000,
							'step' => 5,
						],
						'%' => [
							'min' => 0,
							'max' => 100,
						],
					],
					'selectors' => [
						'{{WRAPPER}} .techtime-button a i' => 'height: {{SIZE}}{{UNIT}};',
					],
				]
			);
			$this->add_control(
				'width',
				[
					'label' => __( 'Width', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => 0,
							'max' => 1000,
							'step' => 5,
						],
						'%' => [
							'min' => 0,
							'max' => 100,
						],
					],
					'selectors' => [
						'{{WRAPPER}} .techtime-button a i' => 'width: {{SIZE}}{{UNIT}};',
					],
				]
			);
			$this->add_group_control(
				Group_Control_Typography::get_type(),
				[
					'name' => 'icon_typography',
					'selector' => '{{WRAPPER}} .techtime-button a i',
				]
			);
		
		$this->end_controls_section();

		$this->start_controls_section(
			'content_section_style',
			[
				'label' => __( 'Content', 'techtime-elementor-extension' ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);

			$this->add_control(
				'heading_title',
				[
					'label' => __( 'Title', 'techtime-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::HEADING,
					'separator' => 'before',
				]
			);
			
			
    		$this->start_controls_tabs(
    			'title_tabs'
    		);
    		
        		$this->start_controls_tab(
        			'title_normal_tab',
        			[
        				'label' => __( 'Normal', 'techtime-elementor-extension' ),
        			]
        		);
        			$this->add_control(
        				'title_color',
        				[
        					'label' => __( 'Color', 'techtime-elementor-extension' ),
        					'type' => \Elementor\Controls_Manager::COLOR,
        					'default' => '',
        					'selectors' => [
        						'{{WRAPPER}} .techtime-button a' => 'color: {{VALUE}};',
        					],
        				]
        			);
        			$this->add_group_control(
        				\Elementor\Group_Control_Typography::get_type(),
        				[
        					'name' => 'title_typography',
        					'selector' => '{{WRAPPER}} .techtime-button a',
        				]
        			);
        		$this->end_controls_tab();
        		
        		$this->start_controls_tab(
        			'title_hover_tab',
        			[
        				'label' => __( 'Hover', 'techtime-elementor-extension' ),
        			]
        		);
        			$this->add_control(
        				'title_hover_color',
        				[
        					'label' => __( 'Color', 'techtime-elementor-extension' ),
        					'type' => \Elementor\Controls_Manager::COLOR,
        					'default' => '',
        					'selectors' => [
        						'{{WRAPPER}} .techtime-button a:hover' => 'color: {{VALUE}};',
        					],
        				]
        			);
        			$this->add_group_control(
        				\Elementor\Group_Control_Typography::get_type(),
        				[
        					'name' => 'title_hover_typography',
        					'selector' => '{{WRAPPER}} .techtime-button a',
        				]
        			);
        		$this->end_controls_tab();
    		
    		$this->end_controls_tabs();
			
			$this->add_control(
				'heading_description',
				[
					'label' => __( 'Description', 'techtime-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::HEADING,
					'separator' => 'before',
				]
			);
			
    		$this->start_controls_tabs(
    			'description_tabs'
    		);
    		
        		$this->start_controls_tab(
        			'description_normal_tab',
        			[
        				'label' => __( 'Normal', 'techtime-elementor-extension' ),
        			]
        		);

        			$this->add_control(
        				'description_color',
        				[
        					'label' => __( 'Color', 'techtime-elementor-extension' ),
        					'type' => \Elementor\Controls_Manager::COLOR,
        					'default' => '',
        					'selectors' => [
        						'{{WRAPPER}} .techtime-button a .techtime-button-box-desc p' => 'color: {{VALUE}};',
        					],
        				]
        			);
        
        			$this->add_group_control(
        				\Elementor\Group_Control_Typography::get_type(),
        				[
        					'name' => 'description_typography',
        					'selector' => '{{WRAPPER}} .techtime-button-box-desc p',
        				]
        			);
        		
        		$this->end_controls_tab();
        		
        		$this->start_controls_tab(
        			'description_hover_tab',
        			[
        				'label' => __( 'Hover', 'techtime-elementor-extension' ),
        			]
        		);
        		
        			$this->add_control(
        				'description_hover_color',
        				[
        					'label' => __( 'Color', 'techtime-elementor-extension' ),
        					'type' => \Elementor\Controls_Manager::COLOR,
        					'default' => '',
        					'selectors' => [
        						'{{WRAPPER}} .techtime-button a:hover .techtime-button-box-desc p' => 'color: {{VALUE}};',
        					],
        				]
        			);
        
        			$this->add_group_control(
        				\Elementor\Group_Control_Typography::get_type(),
        				[
        					'name' => 'description_hover_typography',
        					'selector' => '{{WRAPPER}} .techtime-button a:hover .techtime-button-box-desc p',
        				]
        			);	
        		
        		$this->end_controls_tab();
    		
    		$this->end_controls_tabs();
			
		$this->end_controls_section();

		$this->start_controls_section(
			'box_section_style',
			[
				'label' => __( 'Box', 'techtime-elementor-extension' ),
				'tab' => Controls_Manager::TAB_STYLE,
			]
		);

			$this->add_control(
				'css_class',
				[
					'label' => __( 'CSS Class', 'techtime-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::TEXT,
				]
			);
			$this->start_controls_tabs(
				'box_style_tabs'
			);
				$this->start_controls_tab(
					'box_style_normal_tab',
					[
						'label' => __( 'Normal', 'techtime-elementor-extension' ),
					]
				);
				
					$this->add_group_control(
						\Elementor\Group_Control_Border::get_type(),
						[
							'name' => 'box_border',
							'label' => __( 'Border', 'techtime-elementor-extension' ),
							'selector' => '{{WRAPPER}} .techtime-button a',
						]
					);

					$this->add_responsive_control(
						'box_border_radius',
						[
							'label' => __( 'Border Radius', 'techtime-elementor-extension' ),
							'type' => \Elementor\Controls_Manager::DIMENSIONS,
							'size_units' => [ 'px', 'em', '%' ],
							'selectors' => [
								'{{WRAPPER}} .techtime-button a' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
							],
						]
					);

					$this->add_group_control(
						\Elementor\Group_Control_Box_Shadow::get_type(),
						[
							'name' => 'box_shadow',
							'label' => __( 'Box Shadow', 'techtime-elementor-extension' ),
							'selector' => '{{WRAPPER}} .techtime-button a',
						]
					);

					$this->add_group_control(
						\Elementor\Group_Control_Background::get_type(),
						[
							'name' => 'box_background',
							'label' => __( 'Background', 'techtime-elementor-extension' ),
							'types' => [ 'classic', 'gradient', 'video' ],
							'selector' => '{{WRAPPER}} .techtime-button a',
						]
					);
				
				$this->end_controls_tab();
				
				$this->start_controls_tab(
					'box_style_hover_tab',
					[
						'label' => __( 'Hover', 'techtime-elementor-extension' ),
					]
				);

					$this->add_group_control(
						\Elementor\Group_Control_Border::get_type(),
						[
							'name' => 'hover_box_border',
							'label' => __( 'Border', 'techtime-elementor-extension' ),
							'selector' => '{{WRAPPER}} .techtime-button a:hover',
						]
					);

					$this->add_responsive_control(
						'hover_box_border_radius',
						[
							'label' => __( 'Border Radius', 'techtime-elementor-extension' ),
							'type' => \Elementor\Controls_Manager::DIMENSIONS,
							'size_units' => [ 'px', 'em', '%' ],
							'selectors' => [
								'{{WRAPPER}} .techtime-button a:hover' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
							],
						]
					);

					$this->add_group_control(
						\Elementor\Group_Control_Box_Shadow::get_type(),
						[
							'name' => 'hover_box_shadow',
							'label' => __( 'Box Shadow', 'techtime-elementor-extension' ),
							'selector' => '{{WRAPPER}} .techtime-button a:hover',
						]
					);

					$this->add_group_control(
						\Elementor\Group_Control_Background::get_type(),
						[
							'name' => 'hover_box_background',
							'label' => __( 'Background', 'techtime-elementor-extension' ),
							'types' => [ 'classic', 'gradient', 'video' ],
							'selector' => '{{WRAPPER}} .techtime-button a:hover',
						]
					);
				
				$this->end_controls_tab();
				
			$this->end_controls_tabs();

			$this->add_responsive_control(
				'box_margin',
				[
					'label' => __( 'Margin', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', 'em', '%' ],
					'selectors' => [
						'{{WRAPPER}} .techtime-button a' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
					'separator' => 'before',
				]
			);
			$this->add_responsive_control(
				'box_padding',
				[
					'label' => __( 'Padding', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', 'em', '%' ],
					'selectors' => [
						'{{WRAPPER}} .techtime-button a' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
				]
			);
		$this->end_controls_section();

	}

	protected function render() {

		$settings = $this->get_settings_for_display();

		
		// $this->add_render_attribute( 'i', 'class', $settings['icon'] );
	
		

		?>

		<?php if($settings['select_style']=='one'){ ?>

				<div class="techtime-button-box">
					<?php if( 'yes'===$settings['show_button'] ){ ?>
					<div class="techtime-button">
						<a href="<?php echo esc_attr($settings['button_url']['url']); ?>">
							<span><?php echo $settings['button_text']; ?></span>
							<i class="<?php echo esc_attr($settings['button_icon']['value']); ?>"></i>
						</a>
					</div>
					<?php } ?>
				</div>

		<?php }elseif($settings['select_style']=='two'){ ?>		
				<div class="techtime-button-box style2">
					<?php if( 'yes'===$settings['show_button'] ){ ?>
					<div class="techtime-button">
						<a href="<?php echo esc_attr($settings['button_url']['url']); ?>">
							<?php echo $settings['button_text']; ?>
							<i class="<?php echo esc_attr($settings['button_icon']['value']); ?>"></i>						</a>
					</div>
					<?php } ?>
				</div>
			<?php }elseif($settings['select_style']=='three'){ ?>		
				<div class="techtime-button-box style3">
					<?php if( 'yes'===$settings['show_button'] ){ ?>
					<div class="techtime-button">
						<a href="<?php echo esc_attr($settings['button_url']['url']); ?>">
							<?php echo $settings['button_text']; ?>
							<i class="<?php echo esc_attr($settings['button_icon']['value']); ?>"></i>						</a>
					</div>
					<?php } ?>
				</div>
			<?php }elseif($settings['select_style']=='four'){ ?>		
				<div class="techtime-button-box style4">
					<?php if( 'yes'===$settings['show_button'] ){ ?>
					<div class="techtime-button">
						<a href="<?php echo esc_attr($settings['button_url']['url']); ?>">
							<?php echo $settings['button_text']; ?>
							<i class="<?php echo esc_attr($settings['button_icon']['value']); ?>"></i>						
						</a>
					</div>
					<?php } ?>
				</div>

		<?php } ?>

	<?php
	}
}