<?php

use Elementor\Controls_Manager;
use Elementor\Group_Control_Typography;

if(!defined('ABSPATH')) exit;

class CaseStudy extends \Elementor\Widget_Base{

	public function get_name(){
		return "casestudy";
	}
	
	public function get_title(){
		return "Case Study";
	}
	
	public function get_icon(){
		return "eicon-integration";
	}
	public function get_categories(){
		return ['techtime-category'];
	}

	protected function register_controls(){

		$this->start_controls_section(
			'content_section',
			[
				'label' => __( 'Content', 'techtime-elementor-extension' ),
				'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
			]
		);

			$this->add_control(
				'my_image',
				[
					'label' => __( 'Choose Image', 'techtime-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::MEDIA,
					'default' => [
						'url' => \Elementor\Utils::get_placeholder_image_src(),
					],
				]
			);

		$this->end_controls_section();





		
/*
==========
Style Tab
==========
*/

		$this->start_controls_section(
			'general_section',
			[
				'label' => __( 'General', 'techtime-elementor-extension' ),
				'tab' => Controls_Manager::TAB_STYLE,
			]
		);

			$this->add_control(
				'select_style',
				[
					'label' => __( 'Select Style', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::SELECT,
					'options' => [
						'one' => __( 'One', 'techtime-elementor-extension' ),
						'two' => __( 'Two', 'techtime-elementor-extension' ),
						'three' => __( 'Three', 'techtime-elementor-extension' ),
						'four' => __( 'Four', 'techtime-elementor-extension' ),
						'five' => __( 'Five', 'techtime-elementor-extension' ),
						'six' => __( 'Six', 'techtime-elementor-extension' ),
						'seven' => __( 'Seven', 'techtime-elementor-extension' ),
					],
					'default' => 'one',
					
				]
			);
			$this->add_control(
				'overlay_color',
				[
					'label' => __( 'Overlay Color', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::COLOR,
					'default' => '',
					'selectors' => [
						'{{WRAPPER}} .style-two .case-study-thumb:before' => 'background: {{VALUE}};',
					],
				]
			);
		$this->end_controls_section();

		$this->start_controls_section(
			'title_section',
			[
				'label' => __( 'Title', 'techtime-elementor-extension' ),
				'tab' => Controls_Manager::TAB_STYLE,
			]
		);

			$this->start_controls_tabs(
				'title_style_tabs'
			);
				$this->start_controls_tab(
					'title_style_normal_tab',
					[
						'label' => __( 'Normal', 'techtime-elementor-extension' ),
					]
				);
				
					$this->add_control(
						'title_color',
						[
							'label' => __( 'Color', 'techtime-elementor-extension' ),
							'type' => Controls_Manager::COLOR,
							'default' => '',
							'selectors' => [
								'{{WRAPPER}} .em-cases-study-title h2 a' => 'color: {{VALUE}};',
							],
						]
					);
				
				$this->end_controls_tab();
				
				$this->start_controls_tab(
					'title_style_hover_tab',
					[
						'label' => __( 'Hover', 'techtime-elementor-extension' ),
					]
				);

					$this->add_control(
						'hover_title_color',
						[
							'label' => __( 'Color', 'techtime-elementor-extension' ),
							'type' => Controls_Manager::COLOR,
							'default' => '',
							'selectors' => [
								'{{WRAPPER}} .em-cases-study-title h2 a:hover' => 'color: {{VALUE}};',
							],
						]
					);
				
				$this->end_controls_tab();
				
			$this->end_controls_tabs();

			$this->add_responsive_control(
				'title_margin',
				[
					'label' => __( 'Margin', 'techtime-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', 'em', '%' ],
					'selectors' => [
						'{{WRAPPER}} .em-cases-study-title h2' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
					'separator' => 'before',
				]
			);

	        $this->add_group_control(
				Group_Control_Typography::get_type(),
				[
					'name' => 'title_typography',
					'label' => esc_html__( 'Typography', 'techtime-elementor-extension' ),
					'selector' => 
	                    '{{WRAPPER}} .em-cases-study-title h2 a',
				]
			);

		$this->end_controls_section();

		$this->start_controls_section(
			'category_section',
			[
				'label' => __( 'Category', 'techtime-elementor-extension' ),
				'tab' => Controls_Manager::TAB_STYLE,
			]
		);

			$this->add_control(
				'category_color',
				[
					'label' => __( 'Color', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::COLOR,
					'default' => '',
					'selectors' => [
						'{{WRAPPER}} .case_category span' => 'color: {{VALUE}};',
					],
				]
			);

	        $this->add_group_control(
				Group_Control_Typography::get_type(),
				[
					'name' => 'category_typography',
					'label' => esc_html__( 'Typography', 'techtime-elementor-extension' ),
					'selector' => 
	                    '{{WRAPPER}} .case_category span',
				]
			);

		$this->end_controls_section();
	}

	protected function render(){

		$settings = $this->get_settings_for_display();


		?>


			<?php if($settings['select_style']=='one'){ ?>

			<div class="em_load_adn bgimgload case_default case-study style1">					
				<div class="case_wrap case-messonary">
                    <div class="row">
					<?php $the_query = new \WP_Query( array( 'post_type' => 'em_case_study' ) ); ?>
					<?php while ($the_query->have_posts()) : $the_query->the_post();

						$terms = get_the_terms(get_the_ID(), 'em_case_study_cat');						
					?>
						<!-- single case -->
						<div class="col-xl-4 col-md-6 <?php if( !empty( $set_column ) ){echo $set_column;}?> grid-item col-xs-12 col-sm-6" >
							<div class="single_case_study">
								<div id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
									<div class="techtime-single-cases-study">					
										
										<!-- case THUMB -->
										<?php if(has_post_thumbnail()){?>
											<div class="case-study-thumb ">
												<a href="<?php the_permalink(); ?>"> <?php the_post_thumbnail(); ?> </a>										
											</div>									
										<?php } ?>

										 <!-- Content  -->
										<div class="cases-study-content ">
											<div class="case-content-text">

												<!-- Catagory  -->
												<div class="case_category">
													<?php if( $terms ){
														foreach( $terms as $single_slugs ){?>
														<span class="category-item">
															<?php echo $single_slugs->name ;?>
														</span>																			
													<?php }} ?>
												</div>

												<!-- case TITLE -->
												<div class="em-cases-study-title ">
													<h2><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h2>	
												</div>


											</div> 

											<!-- case btn -->
											<div class="em-cases-study-btn ">
												<a href="<?php the_permalink(); ?>"> <i class="flaticon flaticon-right-arrow"></i>  See Project</a>	
											</div>


										</div>	

									</div>
								</div> 
							</div><!--  END SINGLE case -->

							
						
						</div>
					<?php endwhile; ?>	
					<?php wp_reset_query(); ?>
					</div>
				</div>
			</div>

			<?php }elseif($settings['select_style']=='two'){ ?>

			<div class=" case_style_adn_2">				
				<div class="case_wrap case_study_carousel  owl-theme owl-carousel owl-loaded curosel-style style-two">
					
					<?php $the_query = new \WP_Query( array( 'post_type' => 'em_case_study' ) ); ?>
						<?php while ($the_query->have_posts()) : $the_query->the_post(); 	
						
						$terms = get_the_terms(get_the_ID(), 'em_case_study_cat');

						?>
						<!-- single case -->
						<div class="col-md-12 col-xs-12 col-sm-12" >
							<div class="single_case_study">
								<div id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
								<?php $url = wp_get_attachment_url( get_post_thumbnail_id() );
								?>
									<div class="techtime-single-cases-study" style="background: url(<?php echo $url; ?>);">					
										
										<!-- case THUMB -->
										<?php if(has_post_thumbnail()){?>
											<div class="case-study-thumb ">
												<a href="<?php the_permalink(); ?>">  
													<span class="case--icon"><i aria-hidden="true" class="flaticon flaticon-add"></i> </span>
												</a>										
											</div>									
										<?php } ?>

										<!-- Image Inner  -->
										<div class="case-content-image">
											<?php $image = wp_get_attachment_image( get_post_meta( get_the_ID(), 'wiki_test_image_id', 1 ), 'medium' ); ?>
											<?php echo $image;?>
										</div>

										 <!-- Content  -->
										<div class="cases-study-content ">
											<div class="case-content-text">
												<!-- Catagory  -->
												<div class="case_category">
													<?php if( $terms ){
														foreach( $terms as $single_slugs ){?>
														<span class="category-item">
															<?php echo $single_slugs->name ;?>
														</span>																			
													<?php }} ?>
												</div>

												<!-- case TITLE -->
												<div class="em-cases-study-title ">
													<h2><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h2>	
												</div>

											</div> 
										</div>	

									</div><!--  END SINGLE case -->
								</div> 
							</div>
						</div>
						<?php endwhile; ?>	
					<?php wp_reset_query(); ?>
				</div>
			</div>
			<script>
			jQuery(document).ready(function($) {
				"use strict";
				// 6.CASE STUDY CUOROSEL
        			$('.case_study_carousel').owlCarousel({
        				loop: true,
        				autoplay: false,
        				autoplayTimeout: 8000,
        				dots: true,
						dotsEach: true,
						margin: 30,
        				nav: false,
        				navText: ["<i class='flaticon-back-1'></i>", "<i class='fa fa-angle-right'></i>"],
        				responsive: {
        					0: {
        						items: 1
        					},
        					768: {
        						items: 2
        					},
        					992: {
        						items: 2
        					},
        					1000: {
        						items: 2
        					},
							1240: {
        						items: 3
        					},
        					1920: {
        						items: 3
        					}
        				}
        			})		
        			});
        			</script>
			<?php }elseif($settings['select_style']=='three'){ ?>


			<div class=" case_style_adn_2">				
				<div class="case_wrap case_study_carousel owl-carousel owl-loaded case-study-style3 curosel-style">
					
					<?php $the_query = new \WP_Query( array( 'post_type' => 'em_case_study' ) ); ?>
					<?php while ($the_query->have_posts()) : $the_query->the_post(); 
				
					$terms = get_the_terms(get_the_ID(), 'em_case_study_cat');

					?>
						<!-- single case -->
						<div class="col-md-12 col-xs-12 col-sm-12">
							<div class="single_case_study <?php echo esc_attr( $extra_class ); ?>">
								<div id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
									<div class="techtime-single-cases-study ">					
										
										<!-- case THUMB -->
										<?php if(has_post_thumbnail()){?>
											<div class="case-study-thumb ">
												<a href="<?php the_permalink(); ?>"> <?php the_post_thumbnail(); ?> 
												</a>
											</div>									
										<?php } ?>
										
										<div class="cases-study-content">
										
											<div class="case_category">
                								<?php if( $terms ){	
        											foreach( $terms as $single_slugs ){?>
        												<span class="category-item">
        												   <?php echo $single_slugs->name ;?>
        												</span>																			
        											<?php }}?>																			
                								</div>
											<!-- CASE TITLE -->
											<div class="em-cases-study-title ">
												<h2><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h2>	
												
											</div>


											<!-- case Description -->
											<?php if($show_content=='yes'){?>
												
													<!-- case TITLE AND CONTENT -->
													<div class="em-cases-study-inner ">
														<div class="cases-study-content ">					
															<p><?php echo wp_trim_words( get_the_content(), 19, ' ' ); ?></p>
														</div>
													</div>
											
											<?php } ?>
											
											
											<!-- case Read More Button -->
											<?php if($show_button=='yes'){?>
												
												<div class="em-case-study-button">
													<?php if($btn_text){?>
															<a href="<?php the_permalink(); ?>" class="learn_btn"><?php echo $btn_text;?></a>
													<?php } ?>
												</div>											
											
											<?php } ?>
										</div>			
									</div>
								</div> <!--  END SINGLE case -->
	
									
							</div>
						
						</div>
					<?php endwhile; ?>	
					<?php wp_reset_query(); ?>

					
				</div>
			</div>
			<script>
			jQuery(document).ready(function($) {
				"use strict";
				// 6.CASE STUDY CUOROSEL
        			$('.case_study_carousel').owlCarousel({
        				loop: true,
        				autoplay: true,
        				autoplayTimeout: 10000,
        				dots: true,
        				nav: false,
        				navText: ["<i class='flaticon-back-1'></i>", "<i class='fa fa-angle-right'></i>"],
        				responsive: {
        					0: {
        						items: 1
        					},
        					768: {
        						items: 2
        					},
        					992: {
        						items: 4
        					},
        					1000: {
        						items: 4
        					},
        					1920: {
        						items: 5
        					}
        				}
        			})		
        			});
        			</script>

			<?php }elseif($settings['select_style']=='four'){ ?>

			<div class="em_load_adn bgimgload case-style-four">					
				<div class="case_wrap case-messonary">

					<?php $the_query = new \WP_Query( array( 'post_type' => 'em_case_study' ) ); ?>
					<?php while ($the_query->have_posts()) : $the_query->the_post();

						$terms = get_the_terms(get_the_ID(), 'em_case_study_cat');						
					?>
						<!-- single case -->
						<div class="col-md-4 grid-item col-xs-12 col-sm-6" >

							<div class="single_case_study">
							
								<div id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
									<div class="techtime-single-cases-study">					
										
										<!-- case THUMB -->
										<?php if(has_post_thumbnail()){?>
											<div class="case-study-thumb ">
												<a href="<?php the_permalink(); ?>">
													<?php the_post_thumbnail(); ?>
												</a>
											</div>									
										<?php } ?>
										
										<div class="cases-study-content">
										
											<!-- case TITLE -->
											<div class="em-cases-study-title ">
												<h2><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h2>			
											</div>
											<div class="case_category">

													<?php if( $terms ){
														
													foreach( $terms as $single_slugs ){?>
														<span class="category-item">
														   <?php echo $single_slugs->name ;?>
														</span>																			
													<?php }} ?>

											</div>
																									
											<!-- case Description -->
											<?php if($show_content=='yes'){?>
												
													<!-- case TITLE AND CONTENT -->
													<div class="em-cases-study-inner ">
														<div class="cases-study-content ">					
															<p><?php echo wp_trim_words( get_the_content(), 16, ' ' ); ?></p>
														</div>
													</div>
											
											<?php } ?>										
											<!-- case Read More Button -->
											<?php if($show_button=='yes'){?>
												<div class="em-case-study-button">
													<?php if($btn_text){?>
															<a href="<?php the_permalink(); ?>" class="study_btn"><?php echo $btn_text;?></a>
													<?php } ?>
												</div>											
											<?php } ?>
										</div>	
											
									</div>
								</div> <!--  END SINGLE case -->
	
							</div>
						
						</div>
					<?php endwhile; ?>	
					<?php wp_reset_query(); ?>
				</div>
			</div>
			
			<?php }elseif($settings['select_style']=='five'){ ?>

			<div class=" case_style_adn_2">				
				<div class="case_wrap case_study_carousel owl-carousel owl-loaded case-study-style5 curosel-style">
					
					<?php $the_query = new \WP_Query( array( 'post_type' => 'em_case_study' ) ); ?>
					<?php while ($the_query->have_posts()) : $the_query->the_post(); 
				
					$terms = get_the_terms(get_the_ID(), 'em_case_study_cat');

					?>
						<!-- single case -->
							<div class="single_case_study <?php echo esc_attr( $extra_class ); ?>">
								<div id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
									<div class="techtime-single-cases-study ">					
										
										<!-- case THUMB -->
										<?php if(has_post_thumbnail()){?>
											<div class="case-study-thumb ">
												<a href="<?php the_permalink(); ?>"> <?php the_post_thumbnail(); ?> 
												</a>
											</div>									
										<?php } ?>
										
										<div class="cases-study-content">
										
											<div class="case_category">
                								<?php if( $terms ){	
        											foreach( $terms as $single_slugs ){?>
        												<span class="category-item">
        												   <?php echo $single_slugs->name ;?>
        												</span>																			
        											<?php }}?>																			
                								</div>
											<!-- CASE TITLE -->
											<div class="em-cases-study-title ">
												<h2><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h2>	
												
											</div>


											<!-- case Description -->
											<?php if($show_content=='yes'){?>
												
													<!-- case TITLE AND CONTENT -->
													<div class="em-cases-study-inner ">
														<div class="cases-study-content ">					
															<p><?php echo wp_trim_words( get_the_content(), 19, ' ' ); ?></p>
														</div>
													</div>
											
											<?php } ?>
											
											
											<!-- case Read More Button -->
												
												<div class="em-case-study-button">
													
													<a href="<?php the_permalink(); ?>" class="learn_btn">Read More</a>
													
												</div>
										
										</div>			
									</div>
								</div> <!--  END SINGLE case -->
								
							</div>
						
					<?php endwhile; ?>	
					<?php wp_reset_query(); ?>

					
				</div>
			</div>
			<script>
			jQuery(document).ready(function($) {
				"use strict";
				// 6.CASE STUDY CUOROSEL
        			$('.case_study_carousel').owlCarousel({
        				loop: true,
        				autoplay: true,
        				autoplayTimeout: 10000,
        				dots: true,
        				nav: false,
        				navText: ["<i class='flaticon-back-1'></i>", "<i class='fa fa-angle-right'></i>"],
        				responsive: {
        					0: {
        						items: 1
        					},
        					768: {
        						items: 2
        					},
        					992: {
        						items: 4
        					},
        					1000: {
        						items: 4
        					},
        					1920: {
        						items: 5
        					}
        				}
        			})		
        			});
        			</script>			
			<?php }elseif($settings['select_style']=='six'){ ?>

			<div class=" case_style_adn_2">				
				<div class="case_wrap case_study_six owl-carousel owl-loaded curosel-style style-six">
					
					<?php $the_query = new \WP_Query( array( 'post_type' => 'em_case_study' ) ); ?>
					<?php while ($the_query->have_posts()) : $the_query->the_post(); 	
					
					$terms = get_the_terms(get_the_ID(), 'em_case_study_cat');

					?>
						<!-- single case -->
						<div class="col-md-12 col-xs-12 col-sm-12" >
							<div class="single_case_study">
								<div id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
									<div class="techtime-single-cases-study">					
										
										<!-- case THUMB -->
										<?php if(has_post_thumbnail()){?>
											<div class="case-study-thumb ">
												<a href="<?php the_permalink(); ?>"> <?php the_post_thumbnail(); ?> 
												</a>
											</div>									
										<?php } ?>
										
										<div class="cases-study-content ">
										
											<!-- case TITLE -->
											<div class="em-cases-study-title ">
												<h2><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h2>	
												
											</div>
											<div class="case_category">
												
													<?php if( $terms ){
														
													foreach( $terms as $single_slugs ){?>
														<span class="category-item">
														   <?php echo $single_slugs->name ;?>
														</span>																			
													<?php }} ?>

											</div>

											<!-- case Description -->
											<?php if($show_content=='yes'){?>
												
													<!-- case TITLE AND CONTENT -->
													<div class="em-cases-study-inner ">
														<div class="cases-study-content ">					
															<p><?php echo wp_trim_words( get_the_content(), 19, ' ' ); ?></p>
														</div>
													</div>
											
											<?php } ?>
											
											
											<!-- case Read More Button -->
											<?php if($show_button=='yes'){?>
												
												<div class="em-case-study-button">
													<?php if($btn_text){?>
															<a href="<?php the_permalink(); ?>" class="learn_btn"><?php echo $btn_text;?></a>
															<i class="fa fa-long-arrow-right btn_icon"></i>
													<?php } ?>
												</div>											
											
											<?php } ?>
										</div>			
									</div>
								</div> <!--  END SINGLE case -->
							</div>
						</div>
					<?php endwhile; ?>	
					<?php wp_reset_query(); ?>
				</div>
			</div>
			<script>
			jQuery(document).ready(function($) {
				"use strict";
				// 6.CASE STUDY CUOROSEL
                    	$('.case_study_six').owlCarousel({
                    		loop: true,
                    		autoplay: true,
                    		autoplayTimeout: 10000,
                    		dots: true,
                    		nav: false,
                    		navText: ["<i class='flaticon-back-1'></i>", "<i class='fa fa-angle-right'></i>"],
                    		responsive: {
                    			0: {
                    				items: 1
                    			},
                    			768: {
                    				items: 2
                    			},
                    			992: {
                    				items: 3
                    			},
                    			1000: {
                    				items: 3
                    			},
                    			1920: {
                    				items: 3
                    			}
                    		}
                    	})	
        			});
        			</script>			
			
			
			<?php }elseif($settings['select_style']=='seven'){ ?>

		<div class=" case_style_adn_2">				
				<div class="case_wrap  curosel-style style-seven">
				
					<div class="row">
					<?php $the_query = new \WP_Query( array( 
					    'post_type' => 'em_case_study',
					    'posts_per_page' => '2'
					) ); ?>
						<?php while ($the_query->have_posts()) : $the_query->the_post(); 	
						
						$terms = get_the_terms(get_the_ID(), 'em_case_study_cat');

						?>
						<!-- single case -->
						
							<div class="col-lg-6 col-md-6 col-xs-12 col-sm-12" >
							<div class="single_case_study">
								<div id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
									<div class="techtime-single-cases-study">					
										
										<!-- case THUMB -->
										<?php if(has_post_thumbnail()){?>
											<div class="case-study-thumb ">
												<a href="<?php the_permalink(); ?>"> <?php the_post_thumbnail(); ?> 
												</a>
										<div class="cases_study_content ">
										<div class="cases-study-content ">
											<div class="case_category">
													<?php if( $terms ){
														
													foreach( $terms as $single_slugs ){?>
														<span class="category-item">
														   <?php echo $single_slugs->name ;?>
														</span>																			
													<?php }} ?>
											</div>
												<!-- case TITLE -->
											<div class="em-cases-study-title ">
												<h2><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h2>	
												
											</div>

											<!-- case Read More Button -->
				
												<div class="em-case-study-button">
											
															<a href="<?php the_permalink(); ?>" class="learn_btn"><?php echo $btn_text;?><i class="fa fa-long-arrow-right btn_icon"></i></a>
															
												
												</div>											
											
									
										</div>
											</div>	
											</div>									
										<?php } ?>
										
												
									</div>
								</div> <!--  END SINGLE case -->
							</div>
						</div>					
					

						<?php endwhile; ?>	
					<?php wp_reset_query(); ?>
						</div>
				</div>
			</div>
		
			<?php }?>
		<?php
	}
}