<?php



use Elementor\Widget_Base;
use Elementor\Controls_Manager;
use Elementor\Group_Control_Typography;
if(!defined('ABSPATH')) exit;


class Portfolio extends Widget_Base{

	public function get_name(){
		return "portfolio";
	}
	
	public function get_title(){
		return "Portfolio";
	}
	
	public function get_icon(){
		return "eicon-star-o";
	}

	public function get_categories(){
		return ['techtime-category'];
	}

	protected function _register_controls(){

		$this->start_controls_section(
			'tab_section',
			[
				'label' => __( 'Tab', 'techtime-elementor-extension' ),
				'tab' => Controls_Manager::TAB_CONTENT,
			]
		);
		$this->add_control(
			'all_works_text',
			[
				'label' => __( 'All Works Text', 'techtime-elementor-extension' ),
				'type' => Controls_Manager::TEXT,
				'dynamic' => [
					'active' => true,
				],
				'placeholder' => __( 'Enter All Works text', 'techtime-elementor-extension' ),
				'label_block' => true,
				'default' => __( 'All', 'techtime-elementor-extension' ),
			]
		);
		$this->end_controls_section();

		$this->start_controls_section(
			'content_section',
			[
				'label' => __( 'Content', 'techtime-elementor-extension' ),
				'tab' => Controls_Manager::TAB_CONTENT,
			]
		);
		// Blog Column
		$this->add_responsive_control(
			'select_column', [
				'label' => esc_html__( 'Select Column', 'dreamit-elementor-extension' ),
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'col-md-4',
				'dynamic' => [
					'active' => true,
				],
				'options' => [
					'col-lg-4 col-md-6'  => esc_html__( '3 Column', 'dreamit-elementor-extension' ),
					'col-lg-6 col-md-6' => esc_html__( '2 Column', 'dreamit-elementor-extension' ),
					'col-lg-3 col-md-4' => esc_html__( '4 Column', 'dreamit-elementor-extension' ),
				],
			]
		);
		$this->add_control(
			'port_posts', [
				'label' => esc_html__( 'Total Posts', 'dreamit-elementor-extension' ),
				'type' => \Elementor\Controls_Manager::NUMBER,
				'default' => 3,
			]
		);
			$this->add_control(
				'port_desc',
				[
					'label' => esc_html__( 'Portfolio Description', 'techtime-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::TEXTAREA,
					'placeholder' => esc_html__( 'Type Description', 'techtime-elementor-extension' ),
				]
			);
		$this->end_controls_section();
		$this->start_controls_section(
			'button_section',
			[
				'label' => __( 'Button', 'techtime-elementor-extension' ),
				'tab' => Controls_Manager::TAB_CONTENT,
			]
		);
		$this->add_control(
			'show_button',
			[
				'label' => __( 'Show Button', 'techtime-elementor-extension' ),
				'type' => Controls_Manager::SWITCHER,
				'label_on' => __( 'Show', 'techtime-elementor-extension' ),
				'label_off' => __( 'Hide', 'techtime-elementor-extension' ),
				'return_value' => 'yes',
				'default' => 'yes',
			]
		);
			$this->add_control(
				'button_text',
				[
					'label' => __( 'Button Text', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::TEXT,
					'dynamic' => [
						'active' => true,
					],
					'placeholder' => __( 'Enter your button text', 'techtime-elementor-extension' ),
					'label_block' => true,
					'default' => __( 'Read More', 'techtime-elementor-extension' ),
				]
			);
			$this->add_control(
				'button_icon',
				[
					'label' => __( 'Button Icon', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::ICONS,
					'default' => [
						'value' => 'fa fa-angle-right',
						'library' => 'solid',
					],
				]
			);
		$this->end_controls_section();

/*
==========
Style Tab
==========
*/
		$this->start_controls_section(
			'general_section',
			[
				'label' => __( 'General', 'techtime-elementor-extension' ),
				'tab' => Controls_Manager::TAB_STYLE,
			]
		);
			$this->add_control(
				'select_style',
				[
					'label' => __( 'Select Style', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::SELECT,
					'options' => [
						'one' => __( 'One', 'techtime-elementor-extension' ),
						'two' => __( 'Two', 'techtime-elementor-extension' ),
						'three' => __( 'Three', 'techtime-elementor-extension' ),
						'four' => __( 'Four', 'techtime-elementor-extension' ),
						'five' => __( 'Five', 'techtime-elementor-extension' ),
						'six' => __( 'Six', 'techtime-elementor-extension' ),
					],
					'default' => 'three',
					
				]
			);

		$this->end_controls_section();

		$this->start_controls_section(
			'tab_style_section',
			[
				'label' => __( 'Tab', 'techtime-elementor-extension' ),
				'tab' => Controls_Manager::TAB_STYLE,
			]
		);
			$this->add_control(
				'tab_color',
				[
					'label' => __( 'Color', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::COLOR,
					'default' => '',
					'selectors' => [
						'{{WRAPPER}} .current_menu_item' => 'background: {{VALUE}}',
					],
				]
			);
			$this->add_group_control(
				\Elementor\Group_Control_Border::get_type(),
				[
					'name' => 'border',
					'label' => __( 'Border', 'techtime-elementor-extension' ),
					'selector' => '{{WRAPPER}} .portfolio_nav ul li',
				]
			);
			$this->add_control(
				'desc_color',
				[
					'label' => __( 'Description Color', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::COLOR,
					'default' => '',
					'selectors' => [
						'{{WRAPPER}} .single_protfolio .prot_content .portfolio-desc p' => 'color: {{VALUE}}',
					],
				]
			);
			$this->add_group_control(
				Group_Control_Typography::get_type(),
				[
					'label' => __( 'Description Typography', 'techtime-elementor-extension' ),
					'name' => 'description_typography',
					'selector' => '{{WRAPPER}} .single_protfolio .prot_content .portfolio-desc p',
				]
			);
		$this->end_controls_section();
		$this->start_controls_section(
			'button_style',
				[
					'label' => __( 'Button Style', 'techtime' ),
					'tab' => Controls_Manager::TAB_STYLE,
				]
			);

			$this->add_control(
				'btn_color',
				[
					'label' => __( 'Button Color', 'techtime' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'default' => '',
					'selectors' => [
						'{{WRAPPER}} .techtime-port-btn a' => 'color: {{VALUE}}',
					],
				]
			);
			$this->add_group_control(
				Group_Control_Typography::get_type(),
				[
					'label' => __( 'Button Typography', 'techtime-elementor-extension' ),
					'name' => 'button_typography',
					'selector' => '{{WRAPPER}} .techtime-port-btn a',
				]
			);
		$this->end_controls_section();

	}

	protected function render(){

		$settings = $this->get_settings_for_display();
		$select_column = $settings['select_column'];
		$port_posts = $settings['port_posts'];

		if($select_column == 'col-lg-4 col-md-6') {
			$select_column = 'col-lg-4 col-md-6';
		} elseif($select_column == 'col-lg-6 col-md-6'){
			$select_column = 'col-lg-6 col-md-6';
		} elseif($select_column == 'col-lg-3 col-md-4'){ 
			$select_column = 'col-lg-3 col-md-4';			
		}
		

		?>

			<?php if($settings['select_style']=='one'){

				$args = array(
					'post_type' => 'portfolio',
					//'posts_per_page' => $port_posts,
				);
				$the_query = new \WP_Query($args);
			
			?>

				<div class="port_style--one">
					<div class="clearfix prtfolio">
						<div class="col-md-12">
							<div class="portfolio_nav">
								<ul id="filter" class="filter_menu ">
									<li class="current_menu_item" data-filter="*" ><?php echo $settings['all_works_text'];?></li>
								<?php 	
								$categories = get_terms('portfolio_cat');
									foreach ( $categories as $single_category ) {?>
										<li   data-filter=".<?php echo esc_attr( $single_category->slug );?>"><?php echo esc_html( $single_category->name );?></li>
									<?php }?>
								</ul>
							</div>

						</div>				
					</div>

					<div class=" em_load pstyle_1 em_port_container">					
						<div class="prot_wrap">				
							<?php while ($the_query->have_posts()) : $the_query->the_post(); 						
								$terms = get_the_terms(get_the_ID(), 'portfolio_cat');
								$saloption  = get_post_meta( get_the_ID(),'_ttech_saloption', true ); 
								$siimagepop  = get_post_meta( get_the_ID(),'_ttech_siimagepop', true ); 
								$sllink  = get_post_meta( get_the_ID(),'_ttech_sllink', true ); 
								$shyoutub  = get_post_meta( get_the_ID(),'_ttech_shyoutub', true ); 
								$pyoutube  = get_post_meta( get_the_ID(),'_ttech_pyoutube', true ); 
								$svvimeo  = get_post_meta( get_the_ID(),'_ttech_svvimeo', true ); 
								$pvimeo  = get_post_meta( get_the_ID(),'_ttech_pvimeo', true );
								$pshow_cat  = get_post_meta( get_the_ID(),'_ttech_pshow_cat', true ); 
								$pshow_title  = get_post_meta( get_the_ID(),'_ttech_pshow_title', true );
							?>

								<div class="<?php echo $select_column; ?> <?php foreach( $terms as $single_category){echo $single_category->slug. ' ';}?>" >

								<div class="single_protfolio">

									<?php $m_g_image_pop  = get_post_meta( get_the_ID(),'_ttech_m_g_image_pop', true ); 
									if($m_g_image_pop =="m_gshow"){?>

									<div class="prot_thumb">
										<div class="owl-carousel portfolio_gallery_post  curosel-style">	
											<?php
												ttech_slider_o('_ttech_pgellaryu',array(1000,570));									
											?>										
										</div>	

										<div class="prot_content multi_gallery">
											<div class="prot_content_inner">										
												<div class="picon">					
													<a class="portfolio-icon venobox" data-gall="myportfolio" href="<?php echo wp_get_attachment_url( get_post_thumbnail_id( get_the_ID() ), 'full' );?>"><i class="fa fa-photo"></i></a>
													<a href="<?php the_permalink(); ?>"><i class="flaticon-add"></i></a>	
												</div>																													
											</div>
											<div class="porttitle_inner">
												<p>
													<?php if( $terms ){
														
													foreach( $terms as $single_slugs ){?>
														<span class="category-item-p">
														<?php echo $single_slugs->name ;?>
														</span>																			
													<?php }}?>
												</p>
												<h3><a href="<?php the_permalink(); ?>"><?php the_title();?></a></h3>									
											</div>	

												
										</div>

									</div>

									<?php }else{ ?>
										
										<div class="prot_thumb">
											
											<?php the_post_thumbnail();?>

											<div class="prot_content em_port_content ">
												<div class="prot_content_inner">

													<div class="porttitle_inner">
														<p>
															<?php if( $terms ){
															foreach( $terms as $single_slugs ){?>
																<span class="category-item-p">
																<?php echo $single_slugs->name ;?>
																</span>		
															<?php }}?>
														</p>
														<h3><a href="<?php the_permalink(); ?>"><?php the_title();?></a></h3>
														<?php if($pshow_cat=='pcat_show'){ ?>
														
														<?php } ?>
													</div>

												</div>

												<div class="port-back-content">
													<div class="prot_content_inner">
												
														<div class="back_porttitle_inner">
															<p>
																<?php if( $terms ){
																foreach( $terms as $single_slugs ){?>
																	<span class="category-item-p">
																	<?php echo $single_slugs->name ;?>
																	</span>		
																<?php }}?>
															</p>
															<h3><a href="<?php the_permalink(); ?>"><?php the_title();?></a></h3>
															<?php if($pshow_cat=='pcat_show'){ ?>
															
															<?php } ?>
														</div>
														
														<div class="portfolio-desc">
															<p><?php echo $settings['port_desc'] ?></p>
														</div>
														<!-- Portfolio BUTTON -->
															<?php if( 'yes'===$settings['show_button'] ){ ?>
															<div class="techtime-port-btn">
																<a href="<?php the_permalink(); ?>" class="port_btn"><?php echo $settings['button_text']; ?><?php \Elementor\Icons_Manager::render_icon( $settings['button_icon'], [ 'aria-hidden' => 'true' ] ); ?></a>
															</div>
															<?php } ?>

													</div>
												</div>
											</div>	


											
										</div>				
				
									<?php } ?>				
																				
								</div><!-- .single_protfolio -->
							</div><!-- .grid-item .col-xs-12 .col-sm-6 -->
							<?php endwhile; ?>	
							<?php wp_reset_query(); ?>
						</div>
					</div>
				</div>

			<?php }elseif($settings['select_style']=='two'){ 
			
				$args = array(
					'post_type' => 'em_portfolio',
					'posts_per_page' => $port_posts,
				);
				$the_query = new \WP_Query($args);

			?>

					<div class="port_style--two">

						<div class=" em_load pstyle_1 em_port_container">					
							<div class="prot_wrap row">				
								<?php while ($the_query->have_posts()) : $the_query->the_post(); 						
									$terms = get_the_terms(get_the_ID(), 'em_portfolio_cat');
									$saloption  = get_post_meta( get_the_ID(),'_ttech_saloption', true ); 
									$siimagepop  = get_post_meta( get_the_ID(),'_ttech_siimagepop', true ); 
									$sllink  = get_post_meta( get_the_ID(),'_ttech_sllink', true ); 
									$shyoutub  = get_post_meta( get_the_ID(),'_ttech_shyoutub', true ); 
									$pyoutube  = get_post_meta( get_the_ID(),'_ttech_pyoutube', true ); 
									$svvimeo  = get_post_meta( get_the_ID(),'_ttech_svvimeo', true ); 
									$pvimeo  = get_post_meta( get_the_ID(),'_ttech_pvimeo', true );
									$pshow_cat  = get_post_meta( get_the_ID(),'_ttech_pshow_cat', true ); 
									$pshow_title  = get_post_meta( get_the_ID(),'_ttech_pshow_title', true );
								?>

								<div class="<?php echo $select_column; ?> grid-item <?php foreach( $terms as $single_slug){echo $single_slug->slug. ' ';}	?>" >

									<div class="single_protfolio">

										<?php $m_g_image_pop  = get_post_meta( get_the_ID(),'_ttech_m_g_image_pop', true ); 
										if($m_g_image_pop =="m_gshow"){?>

										<div class="prot_thumb">
											<div class="owl-carousel portfolio_gallery_post  curosel-style">	
													<?php
														ttech_slider_o('_ttech_pgellaryu',array(1000,570));									
													?>										
											</div>	


												<div class="prot_content multi_gallery">
													<div class="prot_content_inner">										
														<div class="picon">					
															<a class="portfolio-icon venobox" data-gall="myportfolio" href="<?php echo wp_get_attachment_url( get_post_thumbnail_id( get_the_ID() ), 'full' );?>"><i class="fa fa-photo"></i></a>
															<a href="<?php the_permalink(); ?>"><i class="flaticon-add"></i></a>	
														</div>																													
													</div>
													<div class="porttitle_inner">
														<p>
															<?php if( $terms ){
																
															foreach( $terms as $single_slugs ){?>
																<span class="category-item-p">
																<?php echo $single_slugs->name ;?>
																</span>																			
															<?php }}?>
														</p>
														<h3><a href="<?php the_permalink(); ?>"><?php the_title();?></a></h3>									
													</div>												
													
												</div>

										</div>

										<?php }else{ ?>
											
											<div class="prot_thumb">
												
												<?php the_post_thumbnail();?>

												<div class="prot_content em_port_content ">
													<div class="prot_content_inner">

													<div class="picon">					
														<a class="portfolio-icon venobox" data-gall="myportfolio" href="<?php echo wp_get_attachment_url( get_post_thumbnail_id( get_the_ID() ), 'full' );?>"><i class="fa fa-photo"></i></a>
														<a href="<?php the_permalink(); ?>"><i class="flaticon-add"></i></a>	
													</div>	

													<div class="porttitle_inner">
														<div class="icon">
															<i aria-hidden="true" class="flaticon flaticon-add"></i>
														</div>
														<h3><a href="<?php the_permalink(); ?>"><?php the_title();?></a></h3>
														<p> Etiam massa orci, egestas vel lectus sed, </br> rutrum placerat risus. 
															<?php if( $terms ){
															foreach( $terms as $single_slugs ){?>
																<span class="category-item-p">
																<?php echo $single_slugs->name ;?>
																</span>		
															<?php }}?>
														</p>
														
														<?php if($pshow_cat=='pcat_show'){ ?>
														
														<?php } ?>
													</div>
													
													</div>

													
												</div>		
											</div>				
					
										<?php } ?>				
																					
									</div><!-- .single_protfolio -->
								</div><!-- .grid-item .col-xs-12 .col-sm-6 -->
								<?php endwhile; ?>	
								<?php wp_reset_query(); ?>
							</div>
						</div>
					</div>

			<?php }elseif($settings['select_style']=='three'){
				$args = array(
					'post_type' => 'portfolio',
					//'posts_per_page' => $port_posts,
				);
				$the_query = new \WP_Query($args);
			?>

				<div class="port_style--three">
					<div class="clearfix prtfolio">
						<div class="col-md-12">
							<div class="portfolio_nav">
								<ul id="filter" class="filter_menu ">
									<li class="current_menu_item" data-filter="*" ><?php echo $settings['all_works_text'];?></li>
								<?php 	
								$categories = get_terms('portfolio_cat');
									foreach ( $categories as $single_category ) {?>										
										<li   data-filter=".<?php echo esc_attr( $single_category->slug );?>"><?php echo esc_html( $single_category->name );?></li>
									<?php }?>
								</ul>
							</div>

						</div>				
					</div>

					<div class=" em_load pstyle_1 em_port_container">					
						<div class="prot_wrap row">				
							<?php while ($the_query->have_posts()) : $the_query->the_post(); 						
								$terms = get_the_terms(get_the_ID(), 'portfolio_cat');
								$saloption  = get_post_meta( get_the_ID(),'_ttech_saloption', true ); 
								$siimagepop  = get_post_meta( get_the_ID(),'_ttech_siimagepop', true ); 
								$sllink  = get_post_meta( get_the_ID(),'_ttech_sllink', true ); 
								$shyoutub  = get_post_meta( get_the_ID(),'_ttech_shyoutub', true ); 
								$pyoutube  = get_post_meta( get_the_ID(),'_ttech_pyoutube', true ); 
								$svvimeo  = get_post_meta( get_the_ID(),'_ttech_svvimeo', true ); 
								$pvimeo  = get_post_meta( get_the_ID(),'_ttech_pvimeo', true );
								$pshow_cat  = get_post_meta( get_the_ID(),'_ttech_pshow_cat', true ); 
								$pshow_title  = get_post_meta( get_the_ID(),'_ttech_pshow_title', true );
							?>

							<div class="<?php echo $select_column; ?> <?php foreach( $terms as $single_category){echo $single_category->slug. ' ';}	?>" >

								<div class="single_protfolio">

									<?php $m_g_image_pop  = get_post_meta( get_the_ID(),'_ttech_m_g_image_pop', true ); 
									if($m_g_image_pop =="m_gshow"){?>

									<div class="prot_thumb">
										<div class="owl-carousel portfolio_gallery_post  curosel-style">	
												<?php
													ttech_slider_o('_ttech_pgellaryu',array(1000,570));									
												?>										
										</div>	


											<div class="prot_content multi_gallery">
												<div class="prot_content_inner">										
													<div class="picon">					
														<a class="portfolio-icon venobox" data-gall="myportfolio" href="<?php echo wp_get_attachment_url( get_post_thumbnail_id( get_the_ID() ), 'full' );?>"><i class="fa fa-photo"></i></a>
														<a href="<?php the_permalink(); ?>"><i class="flaticon-add"></i></a>	
													</div>																													
												</div>
												<div class="porttitle_inner">
													<p>
														<?php if( $terms ){
															
														foreach( $terms as $single_slugs ){?>
															<span class="category-item-p">
															<?php echo $single_slugs->name ;?>
															</span>																			
														<?php }}?>
													</p>
													<h3><a href="<?php the_permalink(); ?>"><?php the_title();?></a></h3>									
												</div>												
												
											</div>

									</div>

									<?php }else{ ?>
										
										<div class="prot_thumb">
											
											<?php the_post_thumbnail();?>

											<div class="prot_content em_port_content ">
												<div class="prot_content_inner">

												<div class="picon">					
													<a class="portfolio-icon venobox" data-gall="myportfolio" href="<?php echo wp_get_attachment_url( get_post_thumbnail_id( get_the_ID() ), 'full' );?>"><i class="fa fa-photo"></i></a>
													<a href="<?php the_permalink(); ?>"><i class="flaticon-add"></i></a>	
												</div>	

												<div class="porttitle_inner">

													<h3><a href="<?php the_permalink(); ?>"><?php the_title();?></a></h3>
													<p>
														<?php if( $terms ){
														foreach( $terms as $single_slugs ){?>
															<span class="category-item-p">
															<?php echo $single_slugs->name ;?>
															</span>		
														<?php }}?>
													</p>
													
													<?php if($pshow_cat=='pcat_show'){ ?>
													
													<?php } ?>
												</div>
												
												</div>

												
											</div>		
										</div>				
				
									<?php } ?>				
																				
								</div><!-- .single_protfolio -->
							</div><!-- .grid-item .col-xs-12 .col-sm-6 -->
							<?php endwhile; ?>	
							<?php wp_reset_query(); ?>
						</div>
					</div>
				</div>

				<?php }elseif($settings['select_style']=='four'){ 
				
					$args = array(
						'post_type' => 'em_portfolio',
						'posts_per_page' => $port_posts,
					);
					$the_query = new \WP_Query($args);

				?>

					<div class="port_style--four">
						<div class="clearfix prtfolio">
							<div class="col-md-12">
								<div class="portfolio_nav">
									<ul id="filter" class="filter_menu ">
										<li class="current_menu_item" data-filter="*" ><?php echo $settings['all_works_text'];?></li>
									<?php 	
									$categories = get_terms('em_portfolio_cat');
										foreach ( $categories as $single_category ) {?>										
											<li   data-filter=".<?php echo esc_attr( $single_category->slug );?>"><?php echo esc_html( $single_category->name );?></li>
										<?php }?>
									</ul>
								</div>

							</div>				
						</div>

						<div class=" em_load pstyle_1 em_port_container">					
							<div class="prot_wrap row">				
								<?php while ($the_query->have_posts()) : $the_query->the_post(); 						
									$terms = get_the_terms(get_the_ID(), 'em_portfolio_cat');
									$saloption  = get_post_meta( get_the_ID(),'_ttech_saloption', true ); 
									$siimagepop  = get_post_meta( get_the_ID(),'_ttech_siimagepop', true ); 
									$sllink  = get_post_meta( get_the_ID(),'_ttech_sllink', true ); 
									$shyoutub  = get_post_meta( get_the_ID(),'_ttech_shyoutub', true ); 
									$pyoutube  = get_post_meta( get_the_ID(),'_ttech_pyoutube', true ); 
									$svvimeo  = get_post_meta( get_the_ID(),'_ttech_svvimeo', true ); 
									$pvimeo  = get_post_meta( get_the_ID(),'_ttech_pvimeo', true );
									$pshow_cat  = get_post_meta( get_the_ID(),'_ttech_pshow_cat', true ); 
									$pshow_title  = get_post_meta( get_the_ID(),'_ttech_pshow_title', true );
								?>

								<div class="<?php echo $select_column; ?> grid-item <?php foreach( $terms as $single_slug){echo $single_slug->slug. ' ';}	?>" >

									<div class="single_protfolio">

										<?php $m_g_image_pop  = get_post_meta( get_the_ID(),'_ttech_m_g_image_pop', true ); 
										if($m_g_image_pop =="m_gshow"){?>

										<div class="prot_thumb">
											<div class="owl-carousel portfolio_gallery_post  curosel-style">	
													<?php
														ttech_slider_o('_ttech_pgellaryu',array(1000,570));									
													?>										
											</div>	


												<div class="prot_content multi_gallery">
													<div class="prot_content_inner">										
														<div class="picon">					
															<a class="portfolio-icon venobox" data-gall="myportfolio" href="<?php echo wp_get_attachment_url( get_post_thumbnail_id( get_the_ID() ), 'full' );?>"><i aria-hidden="true" class="flaticon flaticon-photo"></i></a>
															<a href="<?php the_permalink(); ?>"><i class="flaticon-add"></i></a>	
														</div>																													
													</div>
													<div class="porttitle_inner">
														<p>
															<?php if( $terms ){
																
															foreach( $terms as $single_slugs ){?>
																<span class="category-item-p">
																<?php echo $single_slugs->name ;?>
																</span>																			
															<?php }}?>
														</p>
														<h3><a href="<?php the_permalink(); ?>"><?php the_title();?></a></h3>									
													</div>												
													
												</div>

										</div>

										<?php }else{ ?>
											
											<div class="prot_thumb">
												
												<?php the_post_thumbnail();?>

												<div class="prot_content em_port_content ">
													<div class="prot_content_inner">

		

													<div class="porttitle_inner">

														<h3><a href="<?php the_permalink(); ?>"><?php the_title();?></a></h3>
														<p>
															<?php if( $terms ){
															foreach( $terms as $single_slugs ){?>
																<span class="category-item-p">
																<?php echo $single_slugs->name ;?>
																</span>		
															<?php }}?>
														</p>
														
														<?php if($pshow_cat=='pcat_show'){ ?>
														
														<?php } ?>	
													</div>

													<div class="picon">					
														<a href="<?php the_permalink(); ?>"><i class="flaticon-add"></i></a>	
													</div>
													
													</div>

													
												</div>		
											</div>				

										<?php } ?>				
																					
									</div><!-- .single_protfolio -->
								</div><!-- .grid-item .col-xs-12 .col-sm-6 -->
								<?php endwhile; ?>	
								<?php wp_reset_query(); ?>
							</div>
						</div>
					</div>

				<?php }elseif($settings['select_style']=='five'){
					$args = array(
						'post_type' => 'em_portfolio',
						'posts_per_page' => $port_posts,
					);
					$the_query = new \WP_Query($args);	
				?>

					<div class="port_style--five">
						<div class="clearfix prtfolio">
							<div class="col-md-12">
								<div class="portfolio_nav">
									<ul id="filter" class="filter_menu ">
										<li class="current_menu_item" data-filter="*" ><?php echo $settings['all_works_text'];?></li>
									<?php 	
									$categories = get_terms('em_portfolio_cat');
										foreach ( $categories as $single_category ) {?>										
											<li   data-filter=".<?php echo esc_attr( $single_category->slug );?>"><?php echo esc_html( $single_category->name );?></li>
										<?php }?>
									</ul>
								</div>

							</div>				
						</div>

						<div class=" em_load pstyle_1 em_port_container">					
							<div class="prot_wrap row">				
								<?php while ($the_query->have_posts()) : $the_query->the_post(); 						
									$terms = get_the_terms(get_the_ID(), 'em_portfolio_cat');
									$saloption  = get_post_meta( get_the_ID(),'_ttech_saloption', true ); 
									$siimagepop  = get_post_meta( get_the_ID(),'_ttech_siimagepop', true ); 
									$sllink  = get_post_meta( get_the_ID(),'_ttech_sllink', true ); 
									$shyoutub  = get_post_meta( get_the_ID(),'_ttech_shyoutub', true ); 
									$pyoutube  = get_post_meta( get_the_ID(),'_ttech_pyoutube', true ); 
									$svvimeo  = get_post_meta( get_the_ID(),'_ttech_svvimeo', true ); 
									$pvimeo  = get_post_meta( get_the_ID(),'_ttech_pvimeo', true );
									$pshow_cat  = get_post_meta( get_the_ID(),'_ttech_pshow_cat', true ); 
									$pshow_title  = get_post_meta( get_the_ID(),'_ttech_pshow_title', true );
								?>

								<div class="<?php echo $select_column; ?> <?php foreach( $terms as $single_slug){echo $single_slug->slug. ' ';}	?>" >

									<div class="single_protfolio">

										<?php $m_g_image_pop  = get_post_meta( get_the_ID(),'_ttech_m_g_image_pop', true ); 
										if($m_g_image_pop =="m_gshow"){?>

										<div class="prot_thumb">
											<div class="owl-carousel portfolio_gallery_post  curosel-style">	
													<?php
														ttech_slider_o('_ttech_pgellaryu',array(1000,570));									
													?>										
											</div>	


												<div class="prot_content multi_gallery">

													<div class="porttitle_inner">
														<p>
															<?php if( $terms ){
																
															foreach( $terms as $single_slugs ){?>
																<span class="category-item-p">
																<?php echo $single_slugs->name ;?>
																</span>																			
															<?php }}?>
														</p>
														<h3><a href="<?php the_permalink(); ?>"><?php the_title();?></a></h3>									
													</div>	
													
													<div class="prot_content_inner">										
														<div class="picon">					
															<a class="portfolio-icon venobox" data-gall="myportfolio" href="<?php echo wp_get_attachment_url( get_post_thumbnail_id( get_the_ID() ), 'full' );?>"><i class="fa fa-photo"></i></a>
															<a href="<?php the_permalink(); ?>"><i class="flaticon-add"></i></a>	
														</div>														
													</div>
													
												</div>

										</div>

										<?php }else{ ?>
											
											<div class="prot_thumb">
												<?php the_post_thumbnail();?>

											</div>
											<div class="porttitle_inner">
												<h3><a href="<?php the_permalink(); ?>"><?php the_title();?></a></h3>
												<p>
													<?php if( $terms ){
													foreach( $terms as $single_slugs ){?>
														<span class="category-item-p">
														<?php echo $single_slugs->name ;?>
														</span>		
													<?php }}?>
												</p>
												<div class="picon">					
													<a class="portfolio-icon venobox" data-gall="myportfolio" href="<?php echo wp_get_attachment_url( get_post_thumbnail_id( get_the_ID() ), 'full' );?>"><i class="fa fa-photo"></i></a>
													<a href="<?php the_permalink(); ?>"><i class="flaticon-add"></i></a>	
												</div>

											</div>
														
					

										<?php } ?>				
																					
									</div><!-- .single_protfolio -->
								</div><!-- .grid-item .col-xs-12 .col-sm-6 -->
								<?php endwhile; ?>	
								<?php wp_reset_query(); ?>
							</div>
						</div>
					</div>

				<?php }elseif($settings['select_style']=='six'){
					$args = array(
						'post_type' => 'em_portfolio',
						'posts_per_page' => $port_posts,
					);
					$the_query = new \WP_Query($args);	
				?>

					<div class="port_style--six">
						<div class="clearfix prtfolio">
							<div class="col-md-12">
								<div class="portfolio_nav">
									<ul id="filter" class="filter_menu ">
										<li class="current_menu_item" data-filter="*" ><?php echo $settings['all_works_text'];?></li>
									<?php 	
									$categories = get_terms('em_portfolio_cat');
										foreach ( $categories as $single_category ) {?>										
											<li   data-filter=".<?php echo esc_attr( $single_category->slug );?>"><?php echo esc_html( $single_category->name );?></li>
										<?php }?>
									</ul>
								</div>

							</div>				
						</div>

						<div class=" em_load pstyle_1 em_port_container">					
							<div class="prot_wrap row">				
								<?php while ($the_query->have_posts()) : $the_query->the_post(); 						
									$terms = get_the_terms(get_the_ID(), 'em_portfolio_cat');
									$saloption  = get_post_meta( get_the_ID(),'_ttech_saloption', true ); 
									$siimagepop  = get_post_meta( get_the_ID(),'_ttech_siimagepop', true ); 
									$sllink  = get_post_meta( get_the_ID(),'_ttech_sllink', true ); 
									$shyoutub  = get_post_meta( get_the_ID(),'_ttech_shyoutub', true ); 
									$pyoutube  = get_post_meta( get_the_ID(),'_ttech_pyoutube', true ); 
									$svvimeo  = get_post_meta( get_the_ID(),'_ttech_svvimeo', true ); 
									$pvimeo  = get_post_meta( get_the_ID(),'_ttech_pvimeo', true );
									$pshow_cat  = get_post_meta( get_the_ID(),'_ttech_pshow_cat', true ); 
									$pshow_title  = get_post_meta( get_the_ID(),'_ttech_pshow_title', true );
								?>

								<div class="<?php echo $select_column; ?> grid-item <?php foreach( $terms as $single_slug){echo $single_slug->slug. ' ';}	?>" >

									<div class="single_protfolio">

										<?php $m_g_image_pop  = get_post_meta( get_the_ID(),'_ttech_m_g_image_pop', true ); 
										if($m_g_image_pop =="m_gshow"){?>

										<div class="prot_thumb">
											<div class="owl-carousel portfolio_gallery_post  curosel-style">	
													<?php
														ttech_slider_o('_ttech_pgellaryu',array(1000,570));									
													?>										
											</div>	


												<div class="prot_content multi_gallery">
													<div class="prot_content_inner">										
														<div class="picon">					
															<a class="portfolio-icon venobox" data-gall="myportfolio" href="<?php echo wp_get_attachment_url( get_post_thumbnail_id( get_the_ID() ), 'full' );?>"><i class="fa fa-photo"></i></a>
															<a href="<?php the_permalink(); ?>"><i class="flaticon-add"></i></a>	
														</div>																													
													</div>
													<div class="porttitle_inner">
														<p>
															<?php if( $terms ){
																
															foreach( $terms as $single_slugs ){?>
																<span class="category-item-p">
																<?php echo $single_slugs->name ;?>
																</span>																			
															<?php }}?>
														</p>
														<h3><a href="<?php the_permalink(); ?>"><?php the_title();?></a></h3>									
													</div>												
													
												</div>

										</div>

										<?php }else{ ?>
											
											<div class="prot_thumb">
												
												<?php the_post_thumbnail();?>

												<div class="prot_content em_port_content ">
													<div class="prot_content_inner">

													<div class="picon">					
														<a class="portfolio-icon venobox" data-gall="myportfolio" href="<?php echo wp_get_attachment_url( get_post_thumbnail_id( get_the_ID() ), 'full' );?>"><i class="fa fa-photo"></i></a>
														<a href="<?php the_permalink(); ?>"><i class="flaticon-add"></i></a>	
													</div>	

													<div class="porttitle_inner">

														<h3><a href="<?php the_permalink(); ?>"><?php the_title();?></a></h3>
														<p>
															<?php if( $terms ){
															foreach( $terms as $single_slugs ){?>
																<span class="category-item-p">
																<?php echo $single_slugs->name ;?>
																</span>		
															<?php }}?>
														</p>
														
														<?php if($pshow_cat=='pcat_show'){ ?>
														
														<?php } ?>
													</div>
													
													</div>

													
												</div>		
											</div>				
					
										<?php } ?>				
																					
									</div><!-- .single_protfolio -->
								</div><!-- .grid-item .col-xs-12 .col-sm-6 -->
								<?php endwhile; ?>	
								<?php wp_reset_query(); ?>
							</div>
						</div>
					</div>

			<?php } ?>
		<?php

	}
}