<?php

use Elementor\Widget_Base;
use Elementor\Controls_Manager;
use Elementor\Scheme_Typography;
use Elementor\Group_Control_Typography;



function techtime_product_cat_list( ){
	$term_id = 'product_cat';
	$categories = get_terms( $term_id );

	$cat_array['all'] = "All Categories";

	if( !empty($categories)) {
		foreach ($categories as $cat ) {
			$cat_info = get_term($cat, $term_id);
			$cat_array[ $cat_info->slug ] = $cat_info->name;
		}
	}
	return $cat_array;
}


class techtimeProducts extends Widget_Base {

	public function get_name() {
		return "techtimeproducts";
	}

	public function get_title() {
		return "techtime Products";
	}

	public function get_icon() {
		return "eicon-products";
	}

	public function get_categories() {
		return ['techtime-category'];
	}

	protected function register_controls() {

		$this->start_controls_section(
			'section_content',
			[
				'label' => esc_html__( 'Content', 'textdomain' ),
				'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
			]
		);
		$this->add_control(
			'category',
			[
				'label' => __( 'Select Category', 'textdomain' ),
				'type' => Controls_Manager::SELECT2,
				'label_block' => true,
				'multiple' => true,
				'options' => techtime_product_cat_list(),
				'default' => [ 'all' ],
			]
		);
		$this->add_control(
			'limit',
			[
				'label' => __( 'Count', 'textdomain' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'default' => '4',
			]
		);
		$this->add_control(
			'columns',
			[
				'label' => __( 'Columns', 'textdomain' ),
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => '4',
				'options' => [
					'1' => __('1 Column', 'textdomain'),
					'2' => __('2 Column', 'textdomain'),
					'3' => __('3 Column', 'textdomain'),
					'4' => __('4 Column', 'textdomain'),
				],
				
			]
		);


		$this->end_controls_section();



	}

	protected function render() {
		$settings = $this->get_settings_for_display();


		if(empty($settings['category']) OR $settings['category'] == 'all'){
			$cats = '';
		}else {
			$cats = implode(',', $settings['category']);
		}

		echo do_shortcode('[products category="'.$cats.'" limit="'.$settings['limit'].'" columns="'.$settings['columns'].'"]');

	}


}