<?php



use Elementor\Widget_Base;
use Elementor\Controls_Manager;

if(!defined('ABSPATH')) exit;


class Tab extends Widget_Base{

	public function get_name(){
		return "tab";
	}
	
	public function get_title(){
		return "Tab";
	}
	
	public function get_icon(){
		return "eicon-tabs";
	}

	public function get_categories(){
		return ['techtime-category'];
	}

    protected function register_controls(){

		// Tab One

			$this->start_controls_section(
				'tab1_section',
				[
					'label' => __( 'Tab 1', 'techtime-elementor-extension' ),
					'tab' => Controls_Manager::TAB_CONTENT,
				]
			);
			$this->add_control(
				'tab1_text',
				[
					'label' => __( 'Tab Text', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::TEXT,
					'default' => __( 'Default Text', 'techtime-elementor-extension' ),
					'placeholder' => __( 'Type your text here', 'techtime-elementor-extension' ),
				]
			);
			$this->add_control(
				'tab1_image',
				[
					'label' => __( 'Choose Image', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::MEDIA,
					'default' => [
						'url' => \Elementor\Utils::get_placeholder_image_src(),
					],
				]
			);
			$this->add_control(
				'tab1_title',
				[
					'label' => __( 'Title', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::TEXT,
					'default' => __( 'Default title', 'techtime-elementor-extension' ),
					'placeholder' => __( 'Type your title here', 'techtime-elementor-extension' ),
				]
			);
			$this->add_control(
				'tab1_description',
				[
					'label' => __( 'Description', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::TEXTAREA,
					'default' => __( 'Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.', 'techtime-elementor-extension' ),
					'placeholder' => __( 'Type your description here', 'techtime-elementor-extension' ),
				]
			);

			$this->add_control(
				'slides',
				[
					'label' => __( 'Tab Items', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::REPEATER,
					'title_field' => '{{{item_field}}}',
					'icon_field' => '{{{item_field}}}',
					'fields' => [
						[
							'name' => 'item_field',
							'type' => Controls_Manager::TEXT,
							'label_block' => true,
							'default' => 'Title One'
						],						[
							'name' => 'item_field_icon',
							'type' => Controls_Manager::ICONS,
							'label_block' => true,
						],
					],				
				]

			);

			$this->add_control(
				'tab1_button_text',
				[
					'label' => __( 'Button Text', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::TEXT,
					'default' => __( 'Click Here', 'techtime-elementor-extension' ),
					'placeholder' => __( 'Click Here', 'techtime-elementor-extension' ),
				]
			);
    		$this->add_control(
    			'tab1_button_link',
    			[
    				'label' => __( 'Button Link', 'techtime-elementor-extension' ),
    				'type' => \Elementor\Controls_Manager::URL,
    				'placeholder' => __( 'https://your-link.com', 'techtime-elementor-extension' ),
    				'show_external' => true,
    			]
    		);

		$this->end_controls_section();
		
		// Tab Two

		$this->start_controls_section(
			'tab2_section',
				[
					'label' => __( 'Tab 2', 'techtime-elementor-extension' ),
					'tab' => Controls_Manager::TAB_CONTENT,
				]
			);
			$this->add_control(
				'tab2_text',
				[
					'label' => __( 'Tab Text', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::TEXT,
					'default' => __( 'Default Text', 'techtime-elementor-extension' ),
					'placeholder' => __( 'Type your text here', 'techtime-elementor-extension' ),
				]
			);
			$this->add_control(
				'tab2_image',
				[
					'label' => __( 'Choose Image', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::MEDIA,
					'default' => [
						'url' => \Elementor\Utils::get_placeholder_image_src(),
					],
				]
			);
			$this->add_control(
				'tab2_title',
				[
					'label' => __( 'Title', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::TEXT,
					'default' => __( 'Default title', 'techtime-elementor-extension' ),
					'placeholder' => __( 'Type your title here', 'techtime-elementor-extension' ),
				]
			);
			$this->add_control(
				'tab2_description',
				[
					'label' => __( 'Description', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::TEXTAREA,
					'default' => __( 'Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.', 'techtime-elementor-extension' ),
					'placeholder' => __( 'Type your description here', 'techtime-elementor-extension' ),
				]
			);
			$this->add_control(
				'tab2_button_text',
				[
					'label' => __( 'Button Text', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::TEXT,
					'default' => __( 'Click Here', 'techtime-elementor-extension' ),
					'placeholder' => __( 'Click Here', 'techtime-elementor-extension' ),
				]
			);
    		$this->add_control(
    			'tab2_button_link',
    			[
    				'label' => __( 'Button Link', 'techtime-elementor-extension' ),
    				'type' => \Elementor\Controls_Manager::URL,
    				'placeholder' => __( 'https://your-link.com', 'techtime-elementor-extension' ),
    				'show_external' => true,
    			]
    		);

		$this->end_controls_section();
	
		// Tab Three
		
			$this->start_controls_section(
				'tab3_section',
				[
					'label' => __( 'Tab 3', 'techtime-elementor-extension' ),
					'tab' => Controls_Manager::TAB_CONTENT,
				]
			);
			$this->add_control(
				'tab3_text',
				[
					'label' => __( 'Tab Text', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::TEXT,
					'default' => __( 'Default Text', 'techtime-elementor-extension' ),
					'placeholder' => __( 'Type your text here', 'techtime-elementor-extension' ),
				]
			);
			$this->add_control(
				'tab3_image',
				[
					'label' => __( 'Choose Image', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::MEDIA,
					'default' => [
						'url' => \Elementor\Utils::get_placeholder_image_src(),
					],
				]
			);
			$this->add_control(
				'tab3_title',
				[
					'label' => __( 'Title', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::TEXT,
					'default' => __( 'Default title', 'techtime-elementor-extension' ),
					'placeholder' => __( 'Type your title here', 'techtime-elementor-extension' ),
				]
			);
			$this->add_control(
				'tab3_description',
				[
					'label' => __( 'Description', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::TEXTAREA,
					'default' => __( 'Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.', 'techtime-elementor-extension' ),
					'placeholder' => __( 'Type your description here', 'techtime-elementor-extension' ),
				]
			);
			$this->add_control(
				'tab3_button_text',
				[
					'label' => __( 'Button Text', 'techtime-elementor-extension' ),
					'type' => Controls_Manager::TEXT,
					'default' => __( 'Click Here', 'techtime-elementor-extension' ),
					'placeholder' => __( 'Click Here', 'techtime-elementor-extension' ),
				]
			);
    		$this->add_control(
    			'tab3_button_link',
    			[
    				'label' => __( 'Button Link', 'techtime-elementor-extension' ),
    				'type' => \Elementor\Controls_Manager::URL,
    				'placeholder' => __( 'https://your-link.com', 'techtime-elementor-extension' ),
    				'show_external' => true,
    			]
    		);

		$this->end_controls_section();
		
	
/*
==========
Style Tab
==========
*/

		$this->start_controls_section(
			'tab',
			[
				'label' => __( 'Tab', 'techtime-elementor-extension' ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);
		$this->start_controls_tabs(
			'style_tabs'
		);
    		$this->start_controls_tab(
    			'style_normal_tab',
    			[
    				'label' => __( 'Normal', 'techtime-elementor-extension' ),
    			]
    		);
			$this->add_control(
				'tab-background',
				[
					'label' => __( 'Tab Background', 'techtime-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'selectors' => [
						'{{WRAPPER}} .tab .nav-tabs li' => 'background: {{VALUE}}',
					],
				]
			);
			$this->add_control(
				'tab_text_color',
				[
					'label' => __( 'Text Color', 'techtime-elementor-extension' ),
					'type' => \Elementor\Controls_Manager::COLOR,
					'selectors' => [
						'{{WRAPPER}} .tab .nav-tabs li a' => 'color: {{VALUE}}',
					],
				]
			);
    		$this->end_controls_tab();
    		$this->start_controls_tab(
    			'style_active_tab',
    			[
    				'label' => __( 'Active', 'techtime-elementor-extension' ),
    			]
    		);
        		$this->add_control(
        			'active-tab-background',
        			[
        				'label' => __( 'Active Tab Background', 'techtime-elementor-extension' ),
        				'type' => \Elementor\Controls_Manager::COLOR,
        				'selectors' => [
        					'{{WRAPPER}} .tab .nav-tabs li.active' => 'background: {{VALUE}}',
        				],
        			]
        		);
        		$this->add_control(
        			'active_tab_text_color',
        			[
        				'label' => __( 'Text Color', 'techtime-elementor-extension' ),
        				'type' => \Elementor\Controls_Manager::COLOR,
        				'selectors' => [
        					'{{WRAPPER}} .tab .nav-tabs li.active a' => 'color: {{VALUE}}',
        				],
        			]
        		);

			// $this->end_controls_section();

    		$this->end_controls_tab();
		$this->end_controls_tabs();
		$this->end_controls_section();
				
		$this->start_controls_section(
			'title',
			[
				'label' => __( 'Title', 'techtime-elementor-extension' ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);
    		$this->add_control(
    			'title_color',
    			[
    				'label' => __( 'Title Color', 'techtime-elementor-extension' ),
    				'type' => \Elementor\Controls_Manager::COLOR,
    				'selectors' => [
    					'{{WRAPPER}} .tab .tab-content h2' => 'color: {{VALUE}}',
    				],
    			]
    		);
    		$this->add_group_control(
    			\Elementor\Group_Control_Typography::get_type(),
    			[
    				'name' => 'title_typography',
    				'label' => __( 'Typography', 'techtime-elementor-extension' ),
    				'selector' => '{{WRAPPER}} .tab .tab-content h2',
    			]
    		);
		$this->end_controls_section();
				
		
		$this->start_controls_section(
			'description',
			[
				'label' => __( 'Description', 'techtime-elementor-extension' ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);
    		$this->add_control(
    			'description_color',
    			[
    				'label' => __( 'Description Color', 'techtime-elementor-extension' ),
    				'type' => \Elementor\Controls_Manager::COLOR,
    				'selectors' => [
    					'{{WRAPPER}} .tab .tab-content p' => 'color: {{VALUE}}',
    				],
    			]
    		);
    		$this->add_group_control(
    			\Elementor\Group_Control_Typography::get_type(),
    			[
    				'name' => 'description_typography',
    				'label' => __( 'Typography', 'techtime-elementor-extension' ),
    				'selector' => '{{WRAPPER}} .tab .tab-content p',
    			]
    		);
		$this->end_controls_section();
		
    }

    protected function render() {

    	$settings = $this->get_settings_for_display();

    	?>
    	
    	
<div class="tab-section">
	<div class="container">
		<div class="col-lg-12 col-md-12">
			<section class="accordion">
				<div class="row">
					<div class="col-md-2"></div>
					<div class="col-lg-8 col-md-12">
					<section class="accordion-tabs">
						<a class="accordion-tab accordion-active" data-actab-group="0" data-actab-id="0">
							<span class="span-color"><?php echo $settings['tab1_text']; ?></span>
						</a>
						<a class="accordion-tab" data-actab-group="0" data-actab-id="1">
							<span class="span-color"><?php echo $settings['tab2_text']; ?></span>
						</a>
						<a class="accordion-tab" data-actab-group="0" data-actab-id="2">
							<span class="span-color"><?php echo $settings['tab3_text']; ?></span>
						</a>
					</section>
					</div>
					<div class="col-md-2"></div>
				</div>
				<section class="accordion-content">
					<article class="accordion-item accordion-active" data-actab-group="0" data-actab-id="0">
					<h4 class="accordion-item__label"></h4>
						<div class="accordion-item__container">
							<div class="row">
								<div class="col-md-12 col-lg-6">
									<div class="tab-image">
										<img src="<?php echo $settings['tab1_image']['url']; ?>" alt="">
									</div>
								</div>
								<div class="col-md-12 col-lg-6">
									<div class="left-content">
										<h2 class="accordion-item-title"><?php echo $settings['tab1_title']; ?></h2>
										<p><?php echo $settings['tab1_description']; ?></p>
										<div class="tab-items">
											<ul>
												<?php foreach ( $settings['slides'] as $item ) 
												{ ?>
												<li>
													<?php \Elementor\Icons_Manager::render_icon( $item['item_field_icon'], [ 'aria-hidden' => 'true' ] ); ?>
													<?php echo $item['item_field']; ?>
												</li>
												<?php } ?>
											</ul> 
										</div>
										<div class="tab-button">
											<a href="<?php echo esc_url($settings['tab1_button_link']['url']); ?>"><?php echo $settings['tab1_button_text']; ?>
											</a>
										</div>
									</div>
								</div>
							</div>
						</div>
					</article>
					<article class="accordion-item" data-actab-group="0" data-actab-id="1">
					<h4 class="accordion-item__label"></h4>
						<div class="accordion-item__container">
							<div class="row">
								<div class="col-md-12 col-lg-6">
									<div class="tab-image">
										<img src="<?php echo $settings['tab2_image']['url']; ?>" alt="">
									</div>
								</div>
								<div class="col-md-12 col-lg-6">
									<div class="left-content">
										<h2 class="accordion-item-title"><?php echo $settings['tab2_title']; ?></h2>
										<p><?php echo $settings['tab2_description']; ?></p>
										<div class="tab-items">
											<ul>
												<?php foreach ( $settings['slides'] as $item ) 
												{ ?>
												<li>
													<?php \Elementor\Icons_Manager::render_icon( $item['item_field_icon'], [ 'aria-hidden' => 'true' ] ); ?>
													<?php echo $item['item_field']; ?>
												</li>
												<?php } ?>
											</ul> 
										</div>
										<div class="tab-button">
											<a href="<?php echo esc_url($settings['tab2_button_link']['url']); ?>"><?php echo $settings['tab2_button_text']; ?>
											</a>
										</div>
									</div>
								</div>
							</div>
						</div>
					</article>					
					<article class="accordion-item" data-actab-group="0" data-actab-id="2">
					<h4 class="accordion-item__label"></h4>
						<div class="accordion-item__container">
							<div class="row">
								<div class="col-md-12 col-lg-6">
									<div class="tab-image">
										<img src="<?php echo $settings['tab3_image']['url']; ?>" alt="">
									</div>
								</div>
								<div class="col-md-12 col-lg-6">
									<div class="left-content">
										<h2 class="accordion-item-title"><?php echo $settings['tab3_title']; ?></h2>
										<p><?php echo $settings['tab3_description']; ?></p>
										<div class="tab-items">
											<ul>
												<?php foreach ( $settings['slides'] as $item ) 
												{ ?>
												<li>
													<?php \Elementor\Icons_Manager::render_icon( $item['item_field_icon'], [ 'aria-hidden' => 'true' ] ); ?>
													<?php echo $item['item_field']; ?>
												</li>
												<?php } ?>
											</ul> 
										</div>
										<div class="tab-button">
											<a href="<?php echo esc_url($settings['tab3_button_link']['url']); ?>"><?php echo $settings['tab3_button_text']; ?>
											</a>
										</div>
									</div>
								</div>
							</div>
						</div>
					</article>										
				</section>
			</section>
		</div>
	</div>
</div>

    	<?php

    }
}